// --- [ utility.c ] ----------------------------------------------------------

#include <avr/io.h>
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#include "global.h"



#define DELAY_10MS            TRUE
#define MAKE_DEZ_POINT1       TRUE
#define MAKE_DEZ_POINT2       FALSE
#define U_TO_HEX              FALSE

extern char cv[];

uint8_t nibble_to_hex(uint8_t t);

#if DELAY_10MS == TRUE
// ----------------------------------------------------------------------------
// Verzgerungsschleife fr die Dauer von 10ms
void delay_10ms(uint8_t t)
{
   while(t--) _delay_ms(10);
}

#endif

#if MAKE_DEZ_POINT1 == TRUE
// ----------------------------------------------------------------------------
// Fgt VOR dem letzten Zeichen im globalen String cv[] einen Dezimalpunkt ein
// einen Dezimalpunkt ein
void Make_Dez_Point1(void)
{
uint8_t i = 0;

while(cv[i]) i++;									// zum Stringende durchhangeln
cv[i + 1] = 0;										// den neuen Terminator setzen
cv[i] = cv[i-1];									// das letzte Zeichen nach rechts kopieren
cv[i-1] = DEZIMAL_TRENNZEICHEN;				// das Dezimaltrennzeichen einfgen
}
#endif


#if MAKE_DEZ_POINT2 == TRUE
// ----------------------------------------------------------------------------
// Fgt VOR dem vorletzten Zeichen im globalen String cv[] einen Dezimalpunkt ein.
void Make_Dez_Point2(void)
{
uint8_t i = 0;

while (cv[i]) i++;

if (i < 2) return;

cv[i + 1 ] = 0;
cv[i] = cv[i - 1];
cv[i-1] = cv[i - 2];
cv[i - 2] = DEZIMAL_TRENNZEICHEN;
}
#endif



#if U_TO_HEX == TRUE
// ----------------------------------------------------------------------------
// Wandelt einen 8-Bit-Wert in die hexadezimale Darstellung um
// Der String enthlt ggf. eine fhrende 0.
void u_to_hex(uint8_t x, char * t)
{
t[0] = nibble_to_hex(x  >>  4);
t[1] = nibble_to_hex(x & 0x0F);
t[2] = 0;
}

// ----------------------------------------------------------------------------
// wandelt ein Nibble in die hexadezimale Darstellung um
uint8_t nibble_to_hex(uint8_t t)
{
if (t < 10) return('0' + t);
else return(('A' - 10) + t);
}
#endif
// --- [ eof ] ----------------------------------------------------------------
